#! /bin/bash

export TMPDIR=/tmp/$$;

echo "Installed tree: $PREFIX"
echo "using temporary directory: $TMPDIR"

function abort()
{
     /usr/bin/sleep 1; /bin/rm -rf $TMPDIR; exit 1
}
#
trap 'abort' 1 2 3 6 9 15

export BINDIR=${BINDIR}
# export LIBDIR=${PREFIX}/lib/linuxdoc-tools # this is written in ../Makefile
export PERL5LIB=${LIBDIR}:${TMPDIR}

mkdir -m 700 $TMPDIR || exit 1;
mkdir $TMPDIR/Text
sed -e "s,/usr,"${PREFIX}",g" \
  ${PREFIX}/lib/perl5/Text/EntityMap.pm \
  >$TMPDIR/Text/EntityMap.pm

cp -r ${LIBDIR} $TMPDIR

sed -e \
 "s,\$LibDir = \"/usr/lib/linuxdoc-tools\",\$LibDir = \""${TMPDIR}"/linuxdoc-tools\"," \
 -e  "s,\$BinDir = \"/usr/bin\",\$BinDir = \""${BINDIR}"\"," \
 -e "s,\$prefix = \"/usr\",\$prefix = \""${PREFIX}"\"," \
 -e '/use lib \"\/usr\/lib\/linuxdoc-tools\"/a \
use lib \"TMPDIR\";
' \
 -e "s,use lib \"/usr/lib/linuxdoc-tools\",use lib \""${TMPDIR}"/linuxdoc-tools\"," \
 ${BINDIR}/linuxdoc | sed \
  -e "s,use lib \"TMPDIR\",use lib \""${TMPDIR}"\"," \
  -e "s,/usr/bin/sgmlsasp,"${BINDIR}"/sgmlsasp," \
    >$TMPDIR/linuxdoc

chmod u+x $TMPDIR/linuxdoc

sed -e '/global->{NsgmlsOpts} .= \"-D \/usr\/lib\/sgml \"/a \
  $global->{NsgmlsOpts} .= " -c TMPCONFIG"; \
  $global->{NsgmlsOpts} .= " -D TMPLIBDIR1"; \
  $global->{NsgmlsOpts} .= " -D TMPLIBDIR2";
' \
 ${LIBDIR}/LinuxDocTools.pm | sed \
  -e "s,TMPCONFIG,"${PREFIX}"/lib/linuxdoc-tools/dtd/catalog ," \
  -e "s,TMPLIBDIR1,"${PREFIX}"/lib/linuxdoc-tools ," \
  -e "s,TMPLIBDIR2,"${PREFIX}"/lib/sgml ," \
   >$TMPDIR/linuxdoc-tools/LinuxDocTools.pm

if [ -n "`which groff`" ]; then
	ln -s $TMPDIR/linuxdoc $TMPDIR/sgml2txt
	$TMPDIR/sgml2txt ./guide
fi
if [ -n "`which latex`" ]; then
	ln -s $TMPDIR/linuxdoc $TMPDIR/sgml2latex
	$TMPDIR/sgml2latex -o dvi ./guide
fi
if [ -n "`which dvips`" ]; then
	dvips -t letter -o ./guide.ps ./guide.dvi
	if [ -n "`which gzip`" -a -f ./guide.ps ]; then
		gzip -fN ./guide.ps
	fi
fi


ln -s $TMPDIR/linuxdoc $TMPDIR/sgml2info
$TMPDIR/sgml2info ./guide

ln -s $TMPDIR/linuxdoc $TMPDIR/sgml2lyx
$TMPDIR/sgml2lyx ./guide

ln -s $TMPDIR/linuxdoc $TMPDIR/sgml2html
$TMPDIR/sgml2html -I ./guide && mv -f ./guide*.html ./html

ln -s $TMPDIR/linuxdoc $TMPDIR/sgml2rtf
$TMPDIR/sgml2rtf ./guide && if [ ! -d ./rtf ]; \
 then mkdir -m 755 ./rtf; fi && mv -f ./guide*.rtf ./rtf

rm -rf $TMPDIR

exit 0
